Subject: Re: Regression in 32-bit ppc kernel

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sun, 29 Apr 2012 08:42:29 +1000

On Sun, 2012-04-29 at 08:41 +1000, Benjamin Herrenschmidt wrote:
> On Sat, 2012-04-28 at 13:09 -0500, Larry Finger wrote:
> > I have done a little more debugging. The problem is definitely coming
> > from 
> > drivers/tty/serial/pmac_zilog.c. I am getting ChanB interrupts while
> > open, which 
> > causes the following code segment to return IRQ_NONE:
> > 
> >         if (r3 & (CHBEXT | CHBTxIP | CHBRxIP)) {
> >                 if (!ZS_IS_OPEN(uap_a)) {
> >                         pmz_debug("ChanB interrupt while open !\n");
> >                         goto skip_b;
> >                 }
> >                 write_zsreg(uap_b, R0, RES_H_IUS);
> >                 zssync(uap_b);
> >                 if (r3 & CHBEXT)
> > 
> > When this section is entered, r3 == 0x2 (CHBTxIP).
> > 
> > 
> Ok. The debug code was meant to spell "while not open" btw :-)
> 
> I have some ideas what's going on. I think the irda stuff can trigger
> interrupts during the open/close sequence before ZS_IS_OPEN is true.
> 
> I'll send a fix.

Hrm, actually, Andreas also found an actual bug here, as we aren't
testing uap_b but uap_a ... oops. I think when I tested chan b I always
had chan a open :-) That will be easy to fix.

Can you try turning the uap_a to uap_b test above and see if that fixes
some of it for you ?

Cheers,
Ben.